/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.TCoreVariableattr.TCoreVariableattrPath;
import de.ship.db.tables.records.TCoreVariableattrtypeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreVariableattrtype extends TableImpl<TCoreVariableattrtypeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_variableattrtype</code>
     */
    public static final TCoreVariableattrtype T_CORE_VARIABLEATTRTYPE = new TCoreVariableattrtype();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreVariableattrtypeRecord> getRecordType() {
        return TCoreVariableattrtypeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_variableattrtype.lastchange</code>.
     */
    public final TableField<TCoreVariableattrtypeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("CURRENT_TIMESTAMP"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_variableattrtype.pk</code>.
     */
    public final TableField<TCoreVariableattrtypeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_variableattrtype.name</code>. name of
     * the type
     */
    public final TableField<TCoreVariableattrtypeRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "name of the type");

    /**
     * The column <code>common_dd.t_core_variableattrtype.pattern</code>.
     * pattern of the type
     */
    public final TableField<TCoreVariableattrtypeRecord, String> PATTERN = createField(DSL.name("pattern"), SQLDataType.CLOB.nullable(false), this, "pattern of the type");

    private TCoreVariableattrtype(Name alias, Table<TCoreVariableattrtypeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreVariableattrtype(Name alias, Table<TCoreVariableattrtypeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variableattrtype</code> table
     * reference
     */
    public TCoreVariableattrtype(String alias) {
        this(DSL.name(alias), T_CORE_VARIABLEATTRTYPE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_variableattrtype</code> table
     * reference
     */
    public TCoreVariableattrtype(Name alias) {
        this(alias, T_CORE_VARIABLEATTRTYPE);
    }

    /**
     * Create a <code>common_dd.t_core_variableattrtype</code> table reference
     */
    public TCoreVariableattrtype() {
        this(DSL.name("t_core_variableattrtype"), null);
    }

    public <O extends Record> TCoreVariableattrtype(Table<O> path, ForeignKey<O, TCoreVariableattrtypeRecord> childPath, InverseForeignKey<O, TCoreVariableattrtypeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VARIABLEATTRTYPE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreVariableattrtypePath extends TCoreVariableattrtype implements Path<TCoreVariableattrtypeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreVariableattrtypePath(Table<O> path, ForeignKey<O, TCoreVariableattrtypeRecord> childPath, InverseForeignKey<O, TCoreVariableattrtypeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreVariableattrtypePath(Name alias, Table<TCoreVariableattrtypeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreVariableattrtypePath as(String alias) {
            return new TCoreVariableattrtypePath(DSL.name(alias), this);
        }

        @Override
        public TCoreVariableattrtypePath as(Name alias) {
            return new TCoreVariableattrtypePath(alias, this);
        }

        @Override
        public TCoreVariableattrtypePath as(Table<?> alias) {
            return new TCoreVariableattrtypePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreVariableattrtypeRecord, Integer> getIdentity() {
        return (Identity<TCoreVariableattrtypeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreVariableattrtypeRecord> getPrimaryKey() {
        return Keys.PK_CORE_VARIABLEATTRTYPE;
    }

    @Override
    public List<UniqueKey<TCoreVariableattrtypeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_VARIABLEATTRTYPE);
    }

    private transient TCoreVariableattrPath _tCoreVariableattr;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_variableattr</code> table
     */
    public TCoreVariableattrPath tCoreVariableattr() {
        if (_tCoreVariableattr == null)
            _tCoreVariableattr = new TCoreVariableattrPath(this, null, Keys.T_CORE_VARIABLEATTR__FK_COREVARATTR_TYPE.getInverseKey());

        return _tCoreVariableattr;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_variable</code> table
     */
    public TCoreVariablePath tCoreVariable() {
        return tCoreVariableattr().tCoreVariable();
    }

    @Override
    public TCoreVariableattrtype as(String alias) {
        return new TCoreVariableattrtype(DSL.name(alias), this);
    }

    @Override
    public TCoreVariableattrtype as(Name alias) {
        return new TCoreVariableattrtype(alias, this);
    }

    @Override
    public TCoreVariableattrtype as(Table<?> alias) {
        return new TCoreVariableattrtype(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableattrtype rename(String name) {
        return new TCoreVariableattrtype(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableattrtype rename(Name name) {
        return new TCoreVariableattrtype(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreVariableattrtype rename(Table<?> name) {
        return new TCoreVariableattrtype(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattrtype where(Condition condition) {
        return new TCoreVariableattrtype(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattrtype where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattrtype where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattrtype where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattrtype where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattrtype where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattrtype where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreVariableattrtype where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattrtype whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreVariableattrtype whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
